#include "simlib.h"


const double jedna_cesta = 4.0;

Store Kotvy("Sklad kotev", 40);
Facility Stanoviste("Stavoviste");

Histogram dobaCesty("Doba stravena lyzarem u vleku", 0, 1, 15);
Histogram pocetPokusu("Pocet pokusu nastoupit", 1, 1, 10);

Stat	cekaniZavodniku("Doba cekani zavodniku");


// proces volne ujizdejici kotvy
class	 KotvaBezi : public Process {
public:
	KotvaBezi(int t) : Process() { T=t; } ; // T=1 - jedna cesta, T=2 - cesta tam a zpet
	
	void	Behavior() {
		Wait(jedna_cesta*T);
		Leave(Kotvy, 1); // dojede na seradiste a uvolni kotvu
	}
	
	int T;
};



class	 Lyzar : public Process {
public:
	Lyzar(int pri) : Process(pri) {} ;
	
	void	Behavior() {
		double time = Time;
		int pok=0;
		
		Seize(Stanoviste);
		
		cekaniZavodniku(Time-time);
		
		opak:
		Enter(Kotvy, 1);
		
		Wait(Exponential(0.5)); pok++;
		
		if (Random()<=0.1) {
			// nezdareny start, kotva jede sama dve cesty (nahoru, dolu)
			(new KotvaBezi(2))->Activate();
			goto opak;
		}
		
		Release(Stanoviste);
		pocetPokusu(pok);
		
		Wait(jedna_cesta);
		dobaCesty(Time-time);
				
		(new KotvaBezi(1))->Activate(); // nahore opousti kotvu a ta jede sama dolu do skladu
	}
};


// generuje dva typy lyzaru. Obecny predpis
class	Generator : public Event {
public:
	Generator(double interv, int pri) : Event() {
		Interval = interv;
		Pri = pri;
	};
	
	void	Behavior() {
		(new Lyzar(Pri))->Activate();
		Activate(Time+Exponential(Interval));
	}
	
	double	Interval;
	int	Pri;
} ;



int	main()
{
	SetOutput("lyzar.dat");
	Init(0, 1000);
	(new Generator(1,0))->Activate();
	(new Generator(10,1))->Activate();
	Run();
	
	Kotvy.Output();
	Stanoviste.Output();
	dobaCesty.Output();
	pocetPokusu.Output();
	cekaniZavodniku.Output();
}

