#include "simlib.h"

enum {
    VAL_0,
    VAL_1,
    VAL_X
};

#define DELAY 0.001

class Nand : public Process {
public:
    Nand() : Process() { OUT=VAL_X; IN[0]=IN[1]=VAL_X; }
    void Behavior() {
	while (1) {
	    Passivate();
	    if (IN[0]==VAL_X || IN[1]==VAL_X) OUT=VAL_X;
	    else OUT = !(IN[0] && IN[1]);
	    Print("Time==%f, out=%d\n", Time, OUT);
	}
    }
    
    void input(int idx, int val) {
	IN[idx]=val;
	Activate(Time+DELAY);
    }
    
    int OUT;
    int IN[2];
};

class Value : public Event {
public:
    Value(Nand *n, int idx, int val) : N(n) , Event(), Idx(idx), Val(val) {}
    void Behavior() {
	N->input(Idx, Val);
	Cancel();
    }
    
    Nand *N;
    int Idx, Val;
};

int main()
{
    Init(0, 1);
    Nand *n = new Nand;
    n->Activate();
    (new Value(n, 0, 0))->Activate(0.1);
    (new Value(n, 1, 1))->Activate(0.2);
    (new Value(n, 0, 1))->Activate(0.3);
    Run();
}

