#include "simlib.h"

Facility Linka("Prenosova linka");
Histogram hist("Doba v systemu", 100, 100, 15);


class Paket : public Process {
public:
	void Behavior() {
		double time=Time;
		Seize(Linka);
		opak:
		Wait(Uniform(150,250));	// prenos dat
		Wait(5);	// dotaz na uspesnost
		if (Random()<=0.01) goto opak; // 1% chyba, opakovani
		Release(Linka);
		hist(Time-time);
	}
};

class Gener : public Event {
public:
	void Behavior() {
		/*
			20% - vysoka priorita
			40% - stredni
			40% - mala
		*/
		double r = Random();
		Paket *p = new Paket;
		if (r<=0.2) p->Priority=3;
		else
		if (r>0.2 && r<=0.6) p->Priority=2;
		else
			p->Priority=1;
		
		p->Activate();
		Activate(Time+Exponential(250));
	}
	
};

int main()
{
	SetOutput("prenos.dat");
	Init(0,1000*1000);
	(new Gener)->Activate();
	Run();
	Linka.Output();
	hist.Output();
}
