#include "simlib.h"

Facility Linka("Obsluzna linka");

class Transakce;

class Timeout : public Event {
public:
    Timeout(Transakce *to) : Event() , To(to) {
    };
    
    void Behavior();
    
    Transakce *To;
};

class Transakce : public Process {
public:
    void Behavior() {
	double tvstup = Time;

	Timeout *tm = new Timeout(this);
	tm->Activate(Time+15);
	
	Seize(Linka);
	if (Linka.in == this) 
	    tm->Cancel();
	else {
	    Print("Id %d Timeout.....\n", id);
	    return ;
	}
	
	Wait(Exponential(20));
	Release(Linka);
    }
    
    void timeout() {
	Out();
	Activate();
    }
};


void Timeout::Behavior() {
        To->timeout();
	Cancel();
}


class Generator : public Event {
    void Behavior() {
	(new Transakce)->Activate();
	Activate(Time + Exponential(21));
    }
};

int main()
{
    Init(0, 1000);
    (new Generator)->Activate();
    Run();
}

